Index: es_utf8/block_tag_youtube.php
===================================================================
RCS file: /cvsroot/moodle/lang/es_utf8/block_tag_youtube.php,v
retrieving revision 1.2
diff -u -r1.2 block_tag_youtube.php
--- es_utf8/block_tag_youtube.php	22 Aug 2007 15:31:22 -0000	1.2
+++ es_utf8/block_tag_youtube.php	7 Sep 2007 09:50:05 -0000
@@ -3,7 +3,7 @@
       // local modifications from http://127.0.0.1/moodle
 
 
-$string['howtodiy'] = 'How-to & DIY';
+$string['howtodiy'] = 'How-to &amp; DIY';
 $string['anycategory'] = 'Cualquier categoría';
 $string['autosvehicles'] = 'Coches y vehículos';
 $string['blockname'] = 'Youtube';
Index: sr_lt_utf8/block_tag_youtube.php
===================================================================
RCS file: /cvsroot/moodle/lang/sr_lt_utf8/block_tag_youtube.php,v
retrieving revision 1.1
diff -u -r1.1 block_tag_youtube.php
--- sr_lt_utf8/block_tag_youtube.php	27 Aug 2007 19:57:34 -0000	1.1
+++ sr_lt_utf8/block_tag_youtube.php	7 Sep 2007 09:50:05 -0000
@@ -3,22 +3,22 @@
 
 
 $string['anycategory'] = 'Bilo koja kategorija';
-$string['autosvehicles'] = 'Automobili & Vozila';
+$string['autosvehicles'] = 'Automobili &amp; Vozila';
 $string['blockname'] = 'Youtube';
 $string['category'] = 'Kategorija';
 $string['comedy'] = 'Komedija';
 $string['configtitle'] = 'Naslov';
 $string['entertainment'] = 'Razonoda';
-$string['filmsanimation'] = 'Film & Animacija';
-$string['gadgetsgames'] = '\"Naprave\" & Igrice';
-$string['howtodiy'] = 'Praktična uputstva & Uradi sâm';
+$string['filmsanimation'] = 'Film &amp; Animacija';
+$string['gadgetsgames'] = '\"Naprave\" &amp; Igrice';
+$string['howtodiy'] = 'Praktična uputstva &amp; Uradi sâm';
 $string['includeonlyvideosfromplaylist'] = 'Obuhvati samo video filmove sa liste sa id';
 $string['music'] = 'Muzika';
-$string['newspolitics'] = 'Vesti & Politika';
+$string['newspolitics'] = 'Vesti &amp; Politika';
 $string['numberofvideos'] = 'Broj video filmova';
-$string['peopleblogs'] = 'Druženje & Blogovi';
-$string['petsanimals'] = 'Ljubimci & Životinje';
+$string['peopleblogs'] = 'Druženje &amp; Blogovi';
+$string['petsanimals'] = 'Ljubimci &amp; Životinje';
 $string['sports'] = 'Sport';
-$string['travel'] = 'Putovanja & Mesta';
+$string['travel'] = 'Putovanja &amp; Mesta';
 
 ?>
Index: de_utf8/block_tag_youtube.php
===================================================================
RCS file: /cvsroot/moodle/lang/de_utf8/block_tag_youtube.php,v
retrieving revision 1.2
diff -u -r1.2 block_tag_youtube.php
--- de_utf8/block_tag_youtube.php	25 Aug 2007 14:24:09 -0000	1.2
+++ de_utf8/block_tag_youtube.php	7 Sep 2007 09:50:05 -0000
@@ -3,22 +3,22 @@
 
 
 $string['anycategory'] = 'Alle Kategorien';
-$string['autosvehicles'] = 'Autos & Fahrzeuge';
+$string['autosvehicles'] = 'Autos &amp; Fahrzeuge';
 $string['blockname'] = 'YouTube';
 $string['category'] = 'Kategorie';
 $string['comedy'] = 'Comedy';
 $string['configtitle'] = 'Titel';
 $string['entertainment'] = 'Unterhaltung';
-$string['filmsanimation'] = 'Film & Animation';
-$string['gadgetsgames'] = 'Spaß & Spiel';
-$string['howtodiy'] = 'Anleitung & Selbermachen';
+$string['filmsanimation'] = 'Film &amp; Animation';
+$string['gadgetsgames'] = 'Spaß &amp; Spiel';
+$string['howtodiy'] = 'Anleitung &amp; Selbermachen';
 $string['includeonlyvideosfromplaylist'] = 'Nur Videos aus der Playlist mit der ID';
 $string['music'] = 'Musik';
-$string['newspolitics'] = 'Nachrichten & Politik';
+$string['newspolitics'] = 'Nachrichten &amp; Politik';
 $string['numberofvideos'] = 'Anzahl der Videos';
-$string['peopleblogs'] = 'Leute & Tagebücher';
+$string['peopleblogs'] = 'Leute &amp; Tagebücher';
 $string['petsanimals'] = 'Tiere';
 $string['sports'] = 'Sport';
-$string['travel'] = 'Reisen & Orte';
+$string['travel'] = 'Reisen &amp; Orte';
 
 ?>
Index: sr_cr_utf8/block_tag_youtube.php
===================================================================
RCS file: /cvsroot/moodle/lang/sr_cr_utf8/block_tag_youtube.php,v
retrieving revision 1.1
diff -u -r1.1 block_tag_youtube.php
--- sr_cr_utf8/block_tag_youtube.php	27 Aug 2007 19:51:31 -0000	1.1
+++ sr_cr_utf8/block_tag_youtube.php	7 Sep 2007 09:50:05 -0000
@@ -3,22 +3,22 @@
 
 
 $string['anycategory'] = 'Било која категорија';
-$string['autosvehicles'] = 'Аутомобили & Возила';
+$string['autosvehicles'] = 'Аутомобили &amp; Возила';
 $string['blockname'] = 'Youtube';
 $string['category'] = 'Категорија';
 $string['comedy'] = 'Комедија';
 $string['configtitle'] = 'Наслов';
 $string['entertainment'] = 'Разонода';
-$string['filmsanimation'] = 'Филм & Анимација';
-$string['gadgetsgames'] = '\"Направе\" & Игрице';
-$string['howtodiy'] = 'Практична упутства & Уради сâм';
+$string['filmsanimation'] = 'Филм &amp; Анимација';
+$string['gadgetsgames'] = '\"Направе\" &amp; Игрице';
+$string['howtodiy'] = 'Практична упутства &amp; Уради сâм';
 $string['includeonlyvideosfromplaylist'] = 'Обухвати само видео филмове са листе са id';
 $string['music'] = 'Музика';
-$string['newspolitics'] = 'Вести & Политика';
+$string['newspolitics'] = 'Вести &amp; Политика';
 $string['numberofvideos'] = 'Број видео филмова';
-$string['peopleblogs'] = 'Дружење & Блогови';
-$string['petsanimals'] = 'Љубимци & Животиње';
+$string['peopleblogs'] = 'Дружење &amp; Блогови';
+$string['petsanimals'] = 'Љубимци &amp; Животиње';
 $string['sports'] = 'Спорт';
-$string['travel'] = 'Путовања & Места';
+$string['travel'] = 'Путовања &amp; Места';
 
 ?>
Index: fr_utf8/block_tag_youtube.php
===================================================================
RCS file: /cvsroot/moodle/lang/fr_utf8/block_tag_youtube.php,v
retrieving revision 1.1
diff -u -r1.1 block_tag_youtube.php
--- fr_utf8/block_tag_youtube.php	13 Aug 2007 07:56:38 -0000	1.1
+++ fr_utf8/block_tag_youtube.php	7 Sep 2007 09:50:05 -0000
@@ -6,17 +6,17 @@
 $string['category'] = 'Catégorie';
 $string['anycategory'] = 'Toute catégorie';
 $string['includeonlyvideosfromplaylist'] = 'N\'inclure que les vidéos de la liste de lecture d\'identifiant';
-$string['filmsanimation'] = 'Films & animations';
-$string['autosvehicles'] = 'Autos & véhicules';
+$string['filmsanimation'] = 'Films &amp; animations';
+$string['autosvehicles'] = 'Autos &amp; véhicules';
 $string['comedy'] = 'Comédie';
 $string['entertainment'] = 'Entertainment';
 $string['music'] = 'Musique';
-$string['newspolitics'] = 'Nouvelles & politique';
-$string['peopleblogs'] = 'Personnes & blogs';
-$string['petsanimals'] = 'Animaux domestiques & autre animaux';
-$string['howtodiy'] = 'Instructions & bricolage';
+$string['newspolitics'] = 'Nouvelles &amp; politique';
+$string['peopleblogs'] = 'Personnes &amp; blogs';
+$string['petsanimals'] = 'Animaux domestiques &amp; autre animaux';
+$string['howtodiy'] = 'Instructions &amp; bricolage';
 $string['sports'] = 'Sports';
-$string['travel'] = 'Voyages & Lieux';
-$string['gadgetsgames'] = 'Gadgets & jeux';
+$string['travel'] = 'Voyages &amp; Lieux';
+$string['gadgetsgames'] = 'Gadgets &amp; jeux';
 
 ?>
Index: tr_utf8/block_tag_youtube.php
===================================================================
RCS file: /cvsroot/moodle/lang/tr_utf8/block_tag_youtube.php,v
retrieving revision 1.1
diff -u -r1.1 block_tag_youtube.php
--- tr_utf8/block_tag_youtube.php	4 Sep 2007 14:21:25 -0000	1.1
+++ tr_utf8/block_tag_youtube.php	7 Sep 2007 09:50:05 -0000
@@ -4,21 +4,21 @@
 
 
 $string['anycategory'] = 'Herhangi Kategori';
-$string['autosvehicles'] = 'Otomobiller & Araçlar';
+$string['autosvehicles'] = 'Otomobiller &amp; Araçlar';
 $string['blockname'] = 'Youtube';
 $string['category'] = 'Kategori';
 $string['comedy'] = 'Komedi';
 $string['configtitle'] = 'Başlık';
 $string['entertainment'] = 'Eğlence';
-$string['filmsanimation'] = 'Filmler & Çizgi filmler';
-$string['gadgetsgames'] = 'Faydalı Araçlar & Oyunlar';
-$string['howtodiy'] = 'Nasıl yapılır & DIY';
+$string['filmsanimation'] = 'Filmler &amp; Çizgi filmler';
+$string['gadgetsgames'] = 'Faydalı Araçlar &amp; Oyunlar';
+$string['howtodiy'] = 'Nasıl yapılır &amp; DIY';
 $string['music'] = 'Müzik';
-$string['newspolitics'] = 'Haber & Politika';
+$string['newspolitics'] = 'Haber &amp; Politika';
 $string['numberofvideos'] = 'Video sayısı';
-$string['peopleblogs'] = 'Kişiler & Bloglar';
+$string['peopleblogs'] = 'Kişiler &amp; Bloglar';
 $string['petsanimals'] = 'Hayvanlar';
 $string['sports'] = 'Spor';
-$string['travel'] = 'Yolculuk & Yerler';
+$string['travel'] = 'Yolculuk &amp; Yerler';
 
 ?>