Index: course/format/weekscss/format.php
===================================================================
RCS file: /cvsroot/moodle/moodle/course/format/weekscss/format.php,v
retrieving revision 1.22
diff -u -r1.22 format.php
--- course/format/weekscss/format.php	15 Apr 2007 07:26:27 -0000	1.22
+++ course/format/weekscss/format.php	25 Sep 2007 11:57:17 -0000
@@ -184,10 +184,12 @@
 
             $currentweek = (($weekdate <= $timenow) && ($timenow < $nextweekdate));
 
+            $currenttext = '';
             if (!$thissection->visible) {
                 $sectionstyle = ' hidden';
             } else if ($currentweek) {
                 $sectionstyle = ' current';
+                $currenttext = get_accesshide(get_string('currentweek','access'));
             } else {
                 $sectionstyle = '';
             }
@@ -195,7 +197,7 @@
             echo '<li id="section-'.$section.'" class="section main'.$sectionstyle.'" >'; //'<div class="left side">&nbsp;</div>';
 
             // Note, 'right side' is BEFORE content.
-            echo '<div class="right side">';
+            echo '<div class="right side">'.$currenttext;
             
             if ($displaysection == $section) {
                 echo '<a href="view.php?id='.$course->id.'&amp;week=0#section-'.$section.'" title="'.$strshowallweeks.'">'.
Index: course/format/topics/format.php
===================================================================
RCS file: /cvsroot/moodle/moodle/course/format/topics/format.php,v
retrieving revision 1.82
diff -u -r1.82 format.php
--- course/format/topics/format.php	9 May 2007 15:04:52 -0000	1.82
+++ course/format/topics/format.php	25 Sep 2007 11:57:17 -0000
@@ -187,16 +187,18 @@
 
             $currenttopic = ($course->marker == $section);
 
+            $currenttext = '';
             if (!$thissection->visible) {
                 $sectionstyle = ' hidden';
             } else if ($currenttopic) {
                 $sectionstyle = ' current';
+                $currenttext = get_accesshide(get_string('currenttopic','access'));
             } else {
                 $sectionstyle = '';
             }
 
             echo '<tr id="section-'.$section.'" class="section main'.$sectionstyle.'">';
-            echo '<td class="left side">'.$section.'</td>';
+            echo '<td class="left side">'.$currenttext.$section.'</td>';
 
             echo '<td class="content">';
             if (!has_capability('moodle/course:viewhiddensections', $context) and !$thissection->visible) {   // Hidden for students
Index: lang/en_utf8/access.php
===================================================================
RCS file: /cvsroot/moodle/moodle/lang/en_utf8/access.php,v
retrieving revision 1.6
diff -u -r1.6 access.php
--- lang/en_utf8/access.php	1 Nov 2006 09:44:01 -0000	1.6
+++ lang/en_utf8/access.php	25 Sep 2007 11:57:17 -0000
@@ -1,5 +1,6 @@
 <?PHP // $Id: access.php,v 1.6 2006/11/01 09:44:01 moodler Exp $ 
       // access.php - created with Moodle 1.7 beta + (2006101003)
+      // Accessibility, usability and navigation language file.
 
 
 $string['access'] = 'Accessibility';
@@ -9,6 +10,8 @@
 $string['activitynext'] = 'Next activity';
 $string['activityprev'] = 'Previous activity';
 $string['breadcrumb'] = 'Breadcrumb trail';
+$string['currentweek'] = 'Current week ';
+$string['currenttopic'] = 'Current topic ';
 $string['monthnext'] = 'Next month';
 $string['monthprev'] = 'Previous month';
 $string['showhideblock'] = 'Show or hide block';
Index: course/format/weeks/format.php
===================================================================
RCS file: /cvsroot/moodle/moodle/course/format/weeks/format.php,v
retrieving revision 1.73
diff -u -r1.73 format.php
--- course/format/weeks/format.php	27 Aug 2007 16:59:04 -0000	1.73
+++ course/format/weeks/format.php	25 Sep 2007 11:57:17 -0000
@@ -180,19 +180,20 @@
 
             $currentweek = (($weekdate <= $timenow) && ($timenow < $nextweekdate));
 
+            $currenttext = '';
             if (!$thissection->visible) {
                 $sectionstyle = ' hidden';
             } else if ($currentweek) {
                 $sectionstyle = ' current';
+                $currenttext = get_accesshide(get_string('currentweek','access'));
             } else {
                 $sectionstyle = '';
             }
 
             echo '<tr id="section-'.$section.'" class="section main'.$sectionstyle.'">';
-            echo '<td class="left side">&nbsp;</td>';
+            echo '<td class="left side">&nbsp;'.$currenttext.'</td>';
 
             $weekperiod = $weekday.' - '.$endweekday;
-            
 
             echo '<td class="content">';
             if (!has_capability('moodle/course:viewhiddensections', $context) and !$thissection->visible) {   // Hidden for students