Index: mod/glossary/formats/faq/faq_format.php
===================================================================
RCS file: /cvsroot/moodle/moodle/mod/glossary/formats/faq/faq_format.php,v
retrieving revision 1.12
diff -u -r1.12 faq_format.php
--- mod/glossary/formats/faq/faq_format.php	12 Jan 2007 06:57:34 -0000	1.12
+++ mod/glossary/formats/faq/faq_format.php	5 Nov 2007 14:59:00 -0000
@@ -8,16 +8,16 @@
         echo '<table class="glossarypost faq" cellspacing="0">';
 
         echo '<tr valign="top">';
-        echo '<td class="entryheader">';
+        echo '<th class="entryheader">';
         $entry->course = $course->id;
 
         echo '<span class="concept">' . get_string('question','glossary') . ': ';
         glossary_print_entry_concept($entry);
-        echo '</span><br />';
+        echo '</span>';
 
         echo '<span class="time">('.get_string('lastedited').': '.
              userdate($entry->timemodified).')</span>';
-        echo '</td>';
+        echo '</th>';
         echo '<td class="entryattachment">';
 
         glossary_print_entry_approval($cm, $entry, $mode);
Index: mod/glossary/view.php
===================================================================
RCS file: /cvsroot/moodle/moodle/mod/glossary/view.php,v
retrieving revision 1.129
diff -u -r1.129 view.php
--- mod/glossary/view.php	12 Oct 2007 15:55:50 -0000	1.129
+++ mod/glossary/view.php	5 Nov 2007 14:59:00 -0000
@@ -337,10 +337,10 @@
         } else {
             $fullsearchchecked = '';
         }
-        echo '<input type="checkbox" name="fullsearch" value="1" '.$fullsearchchecked.' alt="'.$strsearchindefinition.'" />';
+        echo '<input type="checkbox" name="fullsearch" id="fullsearch" value="1" '.$fullsearchchecked.' />';
         echo '<input type="hidden" name="mode" value="search" />';
         echo '<input type="hidden" name="id" value="'.$cm->id.'" />';
-        echo $strsearchindefinition;
+        echo '<label for="fullsearch">'.$strsearchindefinition.'</label>';
         echo '</td></tr></table>';
 
         echo '</form>';
@@ -439,11 +439,11 @@
                         print_user_picture($user->id, $course->id, $user->picture);
                         $pivottoshow = fullname($user, has_capability('moodle/site:viewfullnames', get_context_instance(CONTEXT_COURSE, $course->id)));
                     } else {
-                        echo '<td align="center">';
+                        echo '<th >';
                     }
 
-                    echo "<strong> $pivottoshow</strong>" ;
-                    echo '</td></tr></table></div>';
+                    print_heading($pivottoshow);
+                    echo '</th></tr></table></div>';
 
                 }
             }
Index: mod/glossary/lib.php
===================================================================
RCS file: /cvsroot/moodle/moodle/mod/glossary/lib.php,v
retrieving revision 1.168.2.7
diff -u -r1.168.2.7 lib.php
--- mod/glossary/lib.php	24 Sep 2007 17:11:43 -0000	1.168.2.7
+++ mod/glossary/lib.php	5 Nov 2007 14:59:00 -0000
@@ -592,7 +592,7 @@
 
  //Default (old) print format used if custom function doesn't exist in format
 function glossary_print_entry_default ($entry) {
-    echo '<b>'. strip_tags($entry->concept) . ': </b>';
+    echo '<h3>'. strip_tags($entry->concept) . ': </h3>';
 
     $definition = $entry->definition;
 
@@ -624,7 +624,7 @@
 function  glossary_print_entry_concept($entry) {
     $options = new object();
     $options->para = false;
-    $text = format_text('<span class="nolink">' . $entry->concept . '</span>', FORMAT_MOODLE, $options);
+    $text = format_text('<h3 class="nolink">' . $entry->concept . '</h3>', FORMAT_MOODLE, $options);
     if (!empty($entry->highlight)) {
         $text = highlight($entry->highlight, $text);
     }
@@ -792,6 +792,8 @@
 
 
     $return = '<span class="commands">';
+    // Differentiate links for each entry.
+    $altsuffix = ': '.$entry->concept;
     if (!$entry->approved) {
         $output = true;
         $return .= get_string('entryishidden','glossary');
@@ -800,7 +802,7 @@
 
     if (has_capability('mod/glossary:comment', $context) and $glossary->allowcomments) {
         $output = true;
-        $return .= ' <a title="' . get_string('addcomment','glossary') . '" href="comment.php?action=add&amp;eid='.$entry->id.'"><img src="comment.gif" class="iconsmall" alt="'.get_string('addcomment','glossary').'" /></a>';
+        $return .= ' <a title="' . get_string('addcomment','glossary') . '" href="comment.php?action=add&amp;eid='.$entry->id.'"><img src="comment.gif" class="iconsmall" alt="'.get_string('addcomment','glossary').$altsuffix.'" /></a>';
     }
 
 
@@ -810,7 +812,7 @@
             $mainglossary = get_record('glossary','mainglossary',1,'course',$course->id);
             if ( $mainglossary ) {  // if there is a main glossary defined, allow to export the current entry
                 $output = true;
-                $return .= ' <a title="'.get_string('exporttomainglossary','glossary') . '" href="exportentry.php?id='.$cm->id.'&amp;entry='.$entry->id.'&amp;mode='.$mode.'&amp;hook='.$hook.'"><img src="export.gif" class="iconsmall" alt="'.get_string('exporttomainglossary','glossary').'" /></a>';
+                $return .= ' <a title="'.get_string('exporttomainglossary','glossary') . '" href="exportentry.php?id='.$cm->id.'&amp;entry='.$entry->id.'&amp;mode='.$mode.'&amp;hook='.$hook.'"><img src="export.gif" class="iconsmall" alt="'.get_string('exporttomainglossary','glossary').$altsuffix.'" /></a>';
             }
         }
 
@@ -828,9 +830,9 @@
             $output = true;
             $return .= " <a title=\"" . get_string("delete") . "\" href=\"deleteentry.php?id=$cm->id&amp;mode=delete&amp;entry=$entry->id&amp;prevmode=$mode&amp;hook=$hook\"><img src=\"";
             $return .= $icon;
-            $return .= "\" class=\"iconsmall\" alt=\"" . get_string("delete") . "\" /></a> ";
+            $return .= "\" class=\"iconsmall\" alt=\"" . get_string("delete") .$altsuffix."\" /></a> ";
 
-            $return .= " <a title=\"" . get_string("edit") . "\" href=\"edit.php?id=$cm->id&amp;e=$entry->id&amp;mode=$mode&amp;hook=$hook\"><img src=\"$CFG->pixpath/t/edit.gif\" class=\"iconsmall\" alt=\"" . get_string("edit") . "\" /></a>";
+            $return .= " <a title=\"" . get_string("edit") . "\" href=\"edit.php?id=$cm->id&amp;e=$entry->id&amp;mode=$mode&amp;hook=$hook\"><img src=\"$CFG->pixpath/t/edit.gif\" class=\"iconsmall\" alt=\"" . get_string("edit") .$altsuffix. "\" /></a>";
         } elseif ( $importedentry ) {
             $return .= " <font size=\"-1\">" . get_string("exportedentry","glossary") . "</font>";
         }
Index: mod/glossary/formats/encyclopedia/encyclopedia_format.php
===================================================================
RCS file: /cvsroot/moodle/moodle/mod/glossary/formats/encyclopedia/encyclopedia_format.php,v
retrieving revision 1.17
diff -u -r1.17 encyclopedia_format.php
--- mod/glossary/formats/encyclopedia/encyclopedia_format.php	12 Jan 2007 06:57:34 -0000	1.17
+++ mod/glossary/formats/encyclopedia/encyclopedia_format.php	5 Nov 2007 14:59:00 -0000
@@ -16,17 +16,17 @@
         print_user_picture($user->id, $course->id, $user->picture);
     
         echo '</td>';
-        echo '<td class="entryheader">';
+        echo '<th class="entryheader">';
         echo '<span class="concept">';
         glossary_print_entry_concept($entry);
-        echo '</span><br />';
+        echo '</span>';
 
         $fullname = fullname($user);
         $by->name = '<a href="'.$CFG->wwwroot.'/user/view.php?id='.$user->id.'&amp;course='.$course->id.'">'.$fullname.'</a>';
         $by->date = userdate($entry->timemodified);
         echo '<span class="author">'.get_string('bynameondate', 'forum', $by).'</span>';
 
-        echo '</td>';
+        echo '</th>';
         
         echo '<td class="entryapproval">';
         glossary_print_entry_approval($cm, $entry, $mode);
Index: theme/standard/styles_fonts.css
===================================================================
RCS file: /cvsroot/moodle/moodle/theme/standard/styles_fonts.css,v
retrieving revision 1.124.2.8
diff -u -r1.124.2.8 styles_fonts.css
--- theme/standard/styles_fonts.css	25 Sep 2007 15:36:43 -0000	1.124.2.8
+++ theme/standard/styles_fonts.css	5 Nov 2007 14:59:00 -0000
@@ -713,8 +713,15 @@
 .glossarypost .time {
   font-size: 0.8em;
 }
-.concept {
-  font-weight: bold;
+.glossarycategoryheader h2 {
+  margin: 0;
+} 
+.glossarypost .concept h3 {
+  margin: 0;
+}
+.glossarypost .entryheader {
+  font-weight: normal;
+  text-align: left;
 }
 .glossarycomment .author {
   font-size: 0.8em;